﻿using DetailRowDemo.Data.Model;
using System;
using System.Collections.Generic;
using System.Dynamic;
using System.IO;
using System.Reflection;
using System.Resources;

namespace DetailRowDemo.Data
{
     public class DataLoader
     {
          static int _minYear = 2004;
          public static Country Import(string IndicatorName, string CountryName)
          {
               string filePath = "DetailRowDemo.Data.Resources." + string.Concat(IndicatorName, ".csv");
               Stream resFilestream = Assembly.GetExecutingAssembly().GetManifestResourceStream(filePath);
               StreamReader reader = new StreamReader(resFilestream);
               var data = reader.ReadToEnd().TrimEnd().Split('\n');

               Country country = new Country();
               for (int i = 1; i < data.Length; i++)
               {
                    string[] _columns = data[i].TrimEnd().Split(',');
                    string _countryname = _columns[0] as string;
                    if (CountryName == _countryname)
                    {
                         country.CountryName = _countryname;
                         country.CountryCode = _columns[1] as string;

                         List<DataItem> values = new List<DataItem>();

                         DataItem dataItem;
                         for (int j = 4; j < _columns.Length; j++)
                         {
                              dataItem = new DataItem();
                              dataItem.Year = $"{_minYear + j - 4}";
                              dataItem.Value = Convert.ToDouble(_columns[j],System.Globalization.CultureInfo.InvariantCulture);
                              values.Add(dataItem);
                         }
                         country.ListOfValues = values;
                         break;
                    }
               }
               return country;
          }
     }
}
