﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
using DetailRowDemo.Data;
using C1.Win.Chart;
using C1.Chart;

namespace DetailRowDemo
{
     public partial class DetailRowContainer : UserControl, IC1FlexGridRowDetail
     {
          string indicatorName = string.Empty;
          public DetailRowContainer()
          {
               InitializeComponent();

               var countries = Properties.Resources.Countries.TrimEnd().Split(',');
               cmbCountry.DataSource = countries;
          }
          public void Setup(C1FlexGrid parentGrid, int rowIndex)
          {
               var bs = new BindingSource();
               bs.DataSource = parentGrid.DataSource as DataTable;
               bs.Position = parentGrid.Rows[rowIndex].DataIndex;
               indicatorName = parentGrid[rowIndex, 3].ToString();

               cmbCountry.SelectedValueChanged += new EventHandler(CmbCountry_SelectedValueChanged);
               cmbCountry.SelectedIndex = 208;
          }
          public void UpdateSize(C1FlexGrid parentGrid, int rowIndex, Size proposedSize)
          {
               this.Width = parentGrid.Width;
          }
          public void Removing(C1FlexGrid parentGrid, int rowIndex)
          {
               cmbCountry.SelectedValueChanged -= new EventHandler(CmbCountry_SelectedValueChanged);
          }
          private void CmbCountry_SelectedValueChanged(object sender, EventArgs e)
          {
               flexChart1.Series.Clear();
               var selectedCountryData = DataLoader.Import(indicatorName, cmbCountry.SelectedItem as string);
               flexChart1.ChartType = ChartType.LineSymbols;
               flexChart1.DataSource = selectedCountryData.ListOfValues;
               flexChart1.Binding = "Value";
               flexChart1.BindingX = "Year";
               flexChart1.Series.Add(new Series());

               flexChart1.ToolTip.Content = "Year: {Year}\nValue: {Value:F3}";
               flexChart1.AxisX.Title = "Year";
               flexChart1.AxisY.Title = "Value";
               flexChart1.Header.Content= $"{indicatorName}";
          }
     }
}
