﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
using C1.Win.C1Themes;
using DetailRowDemo.Data;
namespace DetailRowDemo
{
     public partial class Form1 : Form
     {
          public Form1()
          {
               InitializeComponent();

               #region DataSource: FlexGrid
               DataTable dt = new DataTable();
               dt.Columns.Add("Indicator Code", typeof(string));
               dt.Columns.Add("Indicator Type", typeof(string));
               dt.Columns.Add("Indicator Name", typeof(string));
               dt.Columns.Add("Description", typeof(string));

               dt.Rows.Add("EN.ATM.METH.KT.CE", "Climate Change", "MethaneEmission,kt", "Methane emissions are those stemming from human activities such as agriculture and from industrial methane production.");
               dt.Rows.Add("AG.LND.ARBL.ZS", "Agriculture", "ArableLand,sq km", "Arable land includes land defined by the FAO as land under temporary crops, temporary meadows, market or kitchen gardens, and land temporarily fallow.");
               dt.Rows.Add("EN.ATM.GHGT.KT.CE", "Climate Change", "GreenhouseEmission,kt", "Total greenhouse gas emissions in kt of CO2 equivalent are composed of CO2 totals excluding short-cycle biomass burning but including forest fires, decay of drained peatlands, all anthropogenic CH4 sources, N2O sources and F-gases.");
               dt.Rows.Add("NY.GDP.MKTP.KD.ZG", "Economy", "GDPGrowth,%", "GDP is the sum of gross value added by all resident producers in the economy plus any product taxes and minus any subsidies not included in the value of the products.");
               dt.Rows.Add("SP.POP.GROW", "Climate Change", "PopulationGrowth,%", "Annual population growth rate for year t is the exponential rate of growth of midyear population from year t-1 to t, expressed as a percentage.");
               dt.Rows.Add("FP.CPI.TOTL.ZG", "Economy", "Inflation,%", "Inflation as measured by the consumer price index reflects the annual percentage change in the cost to the average consumer of acquiring a basket of goods and services.");
               dt.Rows.Add("AG.LND.FRST.K2", "Agriculture", "ForestLand,sq km", "Forest area is land under natural or planted stands of trees, whether productive or not, and excludes tree stands in agricultural production systems and trees in urban parks and gardens.");
               dt.Rows.Add("SP.POP.TOTL", "Climate Change", "Population,Total", "Total population is based on the de facto definition of population, which counts all residents regardless of legal status or citizenship.");
               dt.Rows.Add("AG.SRF.TOTL.K2", "Agriculture", "SurfaceArea,sq km", "Surface area is a country's total area, including areas under inland bodies of water and some coastal waterways.");

               c1FlexGrid1.DataSource = dt;
               #endregion

               // sets the delegate method which creates the detail control for displaying
               c1FlexGrid1.RowDetailProvider = (g, r) => new DetailRowContainer();

               // sets the value that specifies when the visiblity of detail control
               c1FlexGrid1.RowDetailsVisibilityMode = RowDetailsVisibilityMode.Collapsed;
               c1FlexGrid1.OwnerDrawCell += C1FlexGrid1_OwnerDrawCell;
          }
          private void Form1_Load(object sender, EventArgs e)
          {
               #region Settings: FlexGrid
               InitializeSettings();
               #endregion
          }
          public void InitializeSettings()
          {
               c1FlexGrid1.ExtendLastCol = true;
               c1FlexGrid1.DrawMode = DrawModeEnum.OwnerDraw;
               foreach (Row rw in c1FlexGrid1.Rows)
               {
                    if (rw.Index > 0)
                    {
                         rw.HeightDisplay = 80;
                         rw.StyleDisplay.WordWrap = true;
                    }
               }
               c1FlexGrid1.AutoSizeCols(0, 3, 10);
          }
          private void C1FlexGrid1_OwnerDrawCell(object sender, OwnerDrawCellEventArgs e)
          {
               if (!e.Measuring && e.Row > 0)
               {
                    c1FlexGrid1.Rows[e.Row].Caption = e.Row.ToString();
               }
          }
     }
}
